(function ($, Drupal, drupalSettings) {

    Drupal.behaviors.ek_jitsi = {
        attach: function (context, settings) {

            $('#meet-start').once().click(function () {
                var videodomain = settings.ek_jitsi.domain;
                const options = {
                    roomName: settings.ek_jitsi.room,
                    width: 600,
                    height: 600,
                    parentNode: document.querySelector('#meet'),
                    userInfo: {
                        email: settings.ek_jitsi.email,
                        displayName: settings.ek_jitsi.user,
                    },
                    interfaceConfigOverwrite: {enableClosePage: true},
                };

                api = new JitsiMeetExternalAPI(videodomain, options);

                $('#meet-stop').show();
                $('#meet-start').hide();
                var m = Drupal.t('Meeting room') + ": " + settings.ek_jitsi.room;
                $('#room').html(m);
                var l = "https://" + videodomain + "/" + settings.ek_jitsi.room;
                $('#link').attr('href',l);
                $('#link').html(Drupal.t('Link'));

            });

            $('#meet-stop').click(function () {
                $('#meet-start').show();
                $('#meet-stop').hide();
                $('#room').html('');
                $('#link').html('');
                $('#link').attr('href','#');
                api.dispose();
            });
        }
    };
})(jQuery, Drupal, drupalSettings);


