<?php

/**
 * @file
 * Contains \Drupal\ek_jitsi\Controller\Video
 */

namespace Drupal\ek_jitsi\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Render\BareHtmlPageRenderer;

/**
 * Controller routines for ek_jitsi module routes.
 */
class Video extends ControllerBase
{

    /**
     *
     */
    public function start()
    {
        $attachments = \Drupal::service('html_response.attachments_processor');
        $renderer = \Drupal::service('renderer');

        $bareHtmlPageRenderer = new BareHtmlPageRenderer($renderer, $attachments);
        
        $content = [];
        if (!\Drupal::config('ek_jitsi_domain')->get('ek_jitsi_domain')) {
            $domain = 'meet.jit.si';
        } else {
            $domain = \Drupal::config('ek_jitsi_domain')->get('ek_jitsi_domain');
        }
        $room = md5(time() + rand());
        $user = \Drupal::currentUser()->getAccountName();
        $mail = \Drupal::currentUser()->getEmail();
        $html = "<div class='meet-wrapper'><div class='button' id='meet-start'>Start</div>";
        $html .= "<div class='button' id='meet-stop'>Stop</div>";
        $html .= "<div class='room' id='room'></div>";
        $html .= "<div class='link'><a id='link' href='#' target='_blank' title='".t('Open in new tab')."'></a></div>";
        $html .= "<div id='meet'></div></div>";
        $content['#markup'] = $html;
        $content['#attached'] = [
            'drupalSettings' => [
                'ek_jitsi' => [
                    'domain' => $domain,
                    'room' => $room,
                    'user' => $user,
                    'email' => $mail,
                    ]
                ],
            'library' => ['ek_jitsi/video' ],
            
        ];
     
        // @todo : make custom theme to render video window
        $response = $bareHtmlPageRenderer->renderBarePage($content, 'New conference', 'maintenance_page');
        return $response;
    }
    
    /**
     * AJAX callback handler
     */
    public function join($id)
    {
        $attachments = \Drupal::service('html_response.attachments_processor');
        $renderer = \Drupal::service('renderer');

        $bareHtmlPageRenderer = new BareHtmlPageRenderer($renderer, $attachments);
        
        $content = [];
        if (!\Drupal::config('ek_jitsi_domain')->get('ek_jitsi_domain')) {
            $domain = 'meet.jit.si';
        } else {
            $domain = \Drupal::config('ek_jitsi_domain')->get('ek_jitsi_domain');
        }
   
        $user = \Drupal::currentUser()->getAccountName();
        $mail = \Drupal::currentUser()->getEmail();
        $html = "<div class='meet-wrapper'><div class='button' id='meet-start'>Start</div>";
        $html .= "<div class='button' id='meet-stop'>Stop</div>";
        $html .= "<div class='room' id='room'></div>";
        $html .= "<div class='link' id='link'></div>";
        $html .= "<div id='meet'></div></div>";
        $content['#markup'] = $html;
        $content['#attached'] = [
            'drupalSettings' => [
                'ek_jitsi' => [
                    'domain' => $domain,
                    'room' => $id,
                    'user' => $user,
                    'email' => $mail,
                    ]
                ],
            'library' => ['ek_jitsi/video' ],
            
        ];
        // @todo : make custom theme to render video window
        $response = $bareHtmlPageRenderer->renderBarePage($content, 'Join conference', 'maintenance_page');
        return $response;
    }
}
